<!-- 一级弹框 -->
<template>
    <div>
        <el-dialog
            :title="title"
            :visible="visible"
            :before-close="handleClose"
            :close-on-click-modal="false"
            width="80%"
            top="10vh"
        >
            <div>
                <el-descriptions title="基础信息" border :column="3">
                    <el-descriptions-item label="项目名称">{{
                        parameter.projectName
                    }}</el-descriptions-item>
                    <el-descriptions-item label="责任单位">{{
                        parameter.projectName
                    }}</el-descriptions-item>
                    <el-descriptions-item label="专项小组">{{
                        parameter.groupName
                    }}</el-descriptions-item>
                    <el-descriptions-item label="牵头市领导">{{
                        parameter.leader
                    }}</el-descriptions-item>
                    <el-descriptions-item label="审核状态">{{
                        parameter.closing === 0 ? '已结项' : '未结项'
                    }}</el-descriptions-item>
                    <el-descriptions-item label="提交时间">{{
                        parameter.leader
                    }}</el-descriptions-item>
                </el-descriptions>
                <div style="margin: 10px 0"></div>
                <el-table
                    stripe
                    size="mini"
                    v-loading="loading"
                    ref="multipleSelection"
                    :data="parameter.pilotSpecificMeasuresList"
                    :max-height="300"
                    :style="{width: '100%'}"
                    @selection-change="handleSelectionChange"
                >
                    <!-- <el-table-column type="selection" width="55" align="center"></el-table-column> -->
                    <el-table-column
                        type="index"
                        label="序号"
                        align="center"
                    ></el-table-column>
                    <el-table-column
                        prop="reformSpecificMeasures"
                        show-overflow-tooltip
                        label="具体举措"
                        align="center"
                    >
                        <template slot-scope="scope">
                            {{
                                scope.row.pilotSpecificMeasures
                                    .reformSpecificMeasures
                            }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        prop="distributionType"
                        show-overflow-tooltip
                        label="分发类型"
                        align="center"
                    >
                        <template slot-scope="scope">
                            {{
                                getDictName(
                                    'fflx',
                                    scope.row.pilotSpecificMeasures
                                        .distributionType
                                )
                            }}
                        </template>
                    </el-table-column>
                    <!-- <el-table-column prop="iteration" show-overflow-tooltip label="责任单位跌代类型" align="center">
						<template slot-scope="scope">
							{{getDictName('zrdwddlx', scope.row.iteration)}}
						</template>
					</el-table-column> -->
                    <el-table-column
                        prop="status"
                        show-overflow-tooltip
                        label="审核状态"
                        align="center"
                    >
                        <template slot-scope="scope">
                            {{
                                getDictName(
                                    'shzt',
                                    scope.row.pilotSpecificMeasures.status
                                )
                            }}
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" align="center">
                        <template slot-scope="scope">
                            <el-link
                                type="primary"
                                :underline="false"
                                class="cloumn-btn"
                                @click="
                                    handleDbClick(
                                        scope.row.pilotSpecificMeasures,
                                        scope.$index
                                    )
                                "
                            >
                                详情
                            </el-link>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <span slot="footer" class="dialog-footer">
                <el-button
                    type="primary"
                    @click="handleSave"
                    :loading="saveloading"
                    >通过</el-button
                >
                <el-button
                    type="warning"
                    @click="submit"
                    :loading="cancelloading"
                    >驳回</el-button
                >
            </span>
        </el-dialog>
        <IterativeDialogDetails
            ref="IterativeDialogDetails"
            @getData="getData"
        ></IterativeDialogDetails>
    </div>
</template>

<script>
import org from '@/api/org.js'
import utils from '@/utils.js'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import measureIterationApplication from '@/api/projectActionIteration/measureIterationApplication.js'
import IterativeDialogDetails from './IterativeDialogDetails.vue'
export default {
    name: 'IterativeDialog',
    components: {
        IterativeDialogDetails,
    },
    data() {
        return {
            visible: false,
            title: '新增',
            loading: false,
            saveloading: false,
            cancelloading: false,
            tableData: [],
            queryParam: {
                pageBean: {
                    page: 1,
                    pageSize: -1,
                },
            },
            parameter: {},
            params: {
                ids: [],
                status: null,
            },
        }
    },
    created() {
        console.log(dictUtils.getDictItemsFromCache('shzt'))
    },
    mounted() {},
    methods: {
        getData(val, index) {
            console.log(val, index)
            if (index >= 0) {
                console.log(1)
                this.$set(this.parameter.pilotSpecificMeasuresList, index, val)
            } else {
                this.parameter.pilotSpecificMeasuresList.push(val)
                this.$set(this.parameter)
            }
        },
        getDictName(code, value) {
            return utils.getDictName(code, value)
        },
        //表格选中
        handleSelectionChange(val) {
            this.multipleSelection = []
            this.$refs.multipleSelection.selection.forEach((item) => {
                this.multipleSelection.push(item.id)
            })
        },
        add(val) {
            console.log(val)
            this.parameter = JSON.parse(JSON.stringify(val))
            this.title = '审核'
            this.visible = true
            this.measureData()
        },
        //获取列表
        measureData() {
            this.loading = true
            // this.parameter.pilotSpecificMeasuresList = []
            this.queryParam.querys = [
                {
                    group: 'main',
                    operation: 'EQUAL',
                    parentGroup: '',
                    property: 'project_id_',
                    relation: 'AND',
                    value: this.parameter.id,
                },
                {
                    group: 'statusGroup',
                    operation: 'EQUAL',
                    parentGroup: '',
                    property: 'status_',
                    relation: 'AND',
                    value: 3,
                },
            ]
            measureIterationApplication.auditQuery(this.queryParam, (res) => {
                if (res.rows) {
                    this.$set(
                        this.parameter,
                        'pilotSpecificMeasuresList',
                        res.rows
                    )
                    // this.$nextTick(() => {
                    // 	this.parameter.pilotSpecificMeasuresList = res.rows
                    // 	//
                    // })
                }
                this.loading = false
            })
        },
        // 关闭新增人员窗口
        handleClose() {
            this.visible = false
            this.parameter = {}
            this.title = ''
        },
        //编辑
        handleDbClick(val) {
            this.$refs.IterativeDialogDetails.edit(val)
        },
        //驳回
        submit() {
            this.cancelloading = true
            this.params.ids = []
            this.parameter.pilotSpecificMeasuresList.forEach((e) => {
                this.params.ids.push(e.pilotSpecificMeasures.id)
            })
            this.params.status = 4
            if (this.params.ids.length <= 0) {
                this.$message.warning('暂无可驳回数据')
                this.cancelloading = false
                return
            }
            measureIterationApplication.auditSave(this.params, (res) => {
                if (res.state) {
                    this.cancelloading = false
                    this.$message.success('驳回成功')
                    this.handleClose()
                }
            })
        },
        // 通过
        handleSave() {
            this.saveloading = true
            this.params.ids = []
            this.parameter.pilotSpecificMeasuresList.forEach((e) => {
                this.params.ids.push(e.pilotSpecificMeasures.id)
            })
            this.params.status = 5
            if (this.params.ids.length <= 0) {
                this.$message.warning('暂无可审核数据')
                this.saveloading = false
                return
            }
            measureIterationApplication.auditSave(this.params, (res) => {
                if (res.state) {
                    this.$message.success('审核成功')
                    this.saveloading = false
                    this.handleClose()
                }
            })
        },
    },
}
</script>

<style lang="scss" scoped>
	@import "~@/assets/css/element-variables.scss";

	.add-btn {
		font-weight: bold;
		cursor: pointer;
		color: $--color-primary;
	}

	.del-btn {
		font-weight: bold;
		margin-left: 10px;
		color: $--color-danger;
		cursor: pointer;
	}

	/deep/.el-dialog__body {
		max-height: 600px;
		overflow-y: auto;

	}
	.cloumn-btn {
	  border: 1px solid #2761ff;
	  padding: 3px 10px;
	  border-radius: 5px;
	  &:nth-child(1) {
	    margin-right: 5px;
	  }
	  &:nth-child(1):hover {
	    background-color: #2761ff;
	    color: #fff;
	  }
	  &:nth-child(2):hover {
	    background-color: #2761ff;
	    color: #fff;
	  }
	  // &:nth-child(2):hover {
	  //   background-color: #f56c6c;
	  //   color: #fff;
	  //   border-color: #f56c6c;
	  // }
	  /deep/ i,
	  span {
	    font-size: 16px;
	  }
	}
</style>
